<i18n>
{
  "fr": {
    "label-1": "Poste",
    "label-2": "Description",
    "label-3": "Scope",
    "label-4": "Autres",
    "label-5": "Total (t eCO2)",
    "post-1": "Emissions directes des sources fixes de combustion",
    "post-2": "Emissions directes des sources mobiles à moteur thermique",
    "post-3": "Emissions directes des procédés hors énergie",
    "post-4": "Emissions directes fugitives",
    "post-5": "Emissions issues de la biomasse (sols et forêts)",
    "post-6": "Emissions indirectes liées à la consommation d'électricité",
    "post-7": "Emissions indirectes liées à la consommation de vapeur, chaleur ou froid",
    "post-8": "Emissions liées à l'énergie non incluses dans les catégories 'émissions directes de GES' et les 'émissions indirectes associées à l’énergie'",
    "post-9": "Achats de produits ou services",
    "post-10": "Immobilisations de biens",
    "post-11": "Déchets",
    "post-12": "Transport de marchandises amont",
    "post-13": "Déplacements professionnels",
    "post-14": "Actifs en leasing amont",
    "post-15": "Investissements",
    "post-16": "Transport de visiteurs et de clients",
    "post-17": "Transport de marchandises aval",
    "post-18": "Utilisation des produits vendus",
    "post-19": "Fin de vie de produits vendus",
    "post-20": "Franchise aval",
    "post-21": "Leasing aval",
    "post-22": "Déplacements domicile travail",
    "post-23": "Autres émissions indirectes",
    "nc": "Non calculé",
    "nc.short": "n.c.",
    "sub-total": "Sous-total"
  },
  "en": {
    "label-1": "Source",
    "label-2": "Description",
    "label-3": "Scope",
    "label-4": "Others",
    "label-5": "Total (t CO2e)",
    "post-1": "Direct emissions from stationary combustion sources.",
    "post-2": "Direct emissions from mobile combustion sources",
    "post-3": "Direct emissions from non-energy processes",
    "post-4": "Direct fugitive emissions",
    "post-5": "Emissions from biomass (soils, forests)",
    "post-6": "Indirect  emissions from purchased electricity",
    "post-7": "Indirect emissions from steam, heating or cooling",
    "post-8": "Energy-related emissions non included in the «Direct emissions» and «Indirect emissions associated with energy» categories",
    "post-9": "Purchased goods and services",
    "post-10": "Fixed assets",
    "post-11": "Waste",
    "post-12": "Upstream transportation of goods",
    "post-13": "Business travel",
    "post-14": "Upstream leased assets",
    "post-15": "Investments",
    "post-16": "Customer and visitor travel",
    "post-17": "Downstream transportation of goods",
    "post-18": "Use of sold products",
    "post-19": "End of life of sold products",
    "post-20": "Downstream franchises",
    "post-21": "Downstream leased assets",
    "post-22": "Employee commuting",
    "post-23": "Other indirect emissions",
    "nc": "Not computed",
    "nc.short": "n.c.",
    "sub-total": "Subtotal"
  }
}
</i18n>

<template>
  <div>
    <contrails-switch
      :withContrails.sync="withContrails"
      @input="process"
    />
    <b-table :data="emissionsPostes" hoverable>
      <b-table-column
        v-slot="props"
        field="poste"
        width="150"
        :label="$t('label-1')"
        centered
      >
        <span v-if="props.row.poste!=='Sous-total'">#</span>{{ props.row.poste }}
      </b-table-column>
      <b-table-column
        field="posteDef"
        width="300"
        :label="$t('label-2')"
        v-slot="props"
      >
        <span v-if="props.row.posteDef.length < 27">
          {{ props.row.posteDef }}
        </span>
        <span v-else>
          <b-tooltip multilined :label="props.row.posteDef" type="is-info">
            {{ props.row.posteDef | nomTronque(25) }}
          </b-tooltip>
        </span>
      </b-table-column>
      <b-table-column
        field="scope"
        :label="$t('label-3')"
        centered
        v-slot="props"
      >
        <span class="tag is-success" v-if="props.row.scope==='1'">
          Scope {{ props.row.scope }}
        </span>
        <span class="tag is-warning" v-if="props.row.scope==='2'">
          Scope {{ props.row.scope }}
        </span>
        <span class="tag is-info" v-if="props.row.scope==='3'">
          Scope {{ props.row.scope }}
        </span>
      </b-table-column>
      <b-table-column
        field="co2"
        label="CO2"
        numeric
        v-slot="props"
      >
        <span v-if="!props.row.computed && isDetailed(props.row)">
          <b-tooltip
            dashed
            :label="$t('nc')"
            type="is-info"
          >
            {{ $t('nc.short') }}
          </b-tooltip>
        </span>
        <span v-else-if="isDetailed(props.row)">
          {{ Math.round(props.row.intensity.co2) | splitNumberTons }}
        </span>
      </b-table-column>
      <b-table-column
        field="ch4"
        label="CH4"
        numeric
        v-slot="props"
      >
        <span v-if="!props.row.computed && isDetailed(props.row)">
          <b-tooltip
            dashed
            :label="$t('nc')"
            type="is-info"
          >
            {{ $t('nc.short') }}
          </b-tooltip>
        </span>
        <span v-else-if="isDetailed(props.row)">
          {{ Math.round(props.row.intensity.ch4) | splitNumberTons }}
        </span>
      </b-table-column>
      <b-table-column
        field="n2o"
        label="N2O"
        v-slot="props"
        numeric
      >
        <span v-if="!props.row.computed && isDetailed(props.row)">
          <b-tooltip
            dashed
            :label="$t('nc')"
            type="is-info"
          >
            {{ $t('nc.short') }}
          </b-tooltip>
        </span>
        <span v-else-if="isDetailed(props.row)">
          {{ Math.round(props.row.intensity.n2o) | splitNumberTons }}
        </span>
      </b-table-column>
      <b-table-column
        field="other"
        v-slot="props"
        :label="$t('label-4')"
        numeric
      >
        <span v-if="!props.row.computed && isDetailed(props.row)">
          <b-tooltip
            dashed
            :label="$t('nc')"
            type="is-info"
          >
            {{ $t('nc.short') }}
          </b-tooltip>
        </span>
        <span v-else-if="isDetailed(props.row)">
          {{ Math.round(props.row.intensity.other) | splitNumberTons }}
        </span>
      </b-table-column>
      <b-table-column
        field="total"
        :label="$t('label-5')"
        v-slot="props"
        width="150"
        numeric
      >
        <span v-if="!props.row.computed">
          <b-tooltip
            dashed
            :label="$t('nc')"
            type="is-info"
          >
            {{ $t('nc.short') }}
          </b-tooltip>
        </span>
        <span v-else-if="withContrails">
          {{ Math.round(props.row.intensity.intensitywc) | splitNumberTons }}
        </span>
        <span v-else>
          {{ Math.round(props.row.intensity.intensity) | splitNumberTons }}
        </span>
      </b-table-column>
      <b-table-column field="poste" label="" centered>
      </b-table-column>
      <template v-slot:footer>
        <th style="width:40px">
          <div class="th-wrap is-centered"> {{ $t('total') }} </div>
        </th>
        <th>
          <div class="th-wrap"></div>
        </th>
        <th>
          <div class="th-wrap"></div>
        </th>
        <th>
          <div class="th-wrap"></div>
        </th>
        <th>
          <div class="th-wrap"></div>
        </th>
        <th>
          <div class="th-wrap"></div>
        </th>
        <th>
          <div class="th-wrap"></div>
        </th>
        <th>
          <div v-if="withContrails" class="th-wrap is-numeric">
            {{ Math.round(intensity.intensitywc) | splitNumberTons }}
          </div>
          <div v-else class="th-wrap is-numeric">
            {{ Math.round(intensity.intensity) | splitNumberTons }}
          </div>
        </th>
        <th>
          <div class="th-wrap">
            <b-tooltip
              :label="$t('display')"
              type="is-black"
            >
              <b-button
                size="is-small"
                icon-right="bar-chart"
                @click="plotsVisible=true"
              />
            </b-tooltip>
            <b-tooltip
              :label="$t('download')"
              type="is-black"
            >
              <b-button
                size="is-small"
                icon-right="download"
                @click="exportTable()"
              />
            </b-tooltip>
          </div>
        </th>
      </template>
    </b-table>
    <b-modal
      :active.sync="plotsVisible"
      has-modal-card
    >
      <div class="modal-card" style="width: 1100px; height: auto">
        <section class="modal-card-body">
          <plots-regulatory
            :title="graphicTitle"
            :data0="graphicDataTons0"
            :data1="graphicDataTons1"
            :data2="graphicDataTons2"
            :drill0="drillDataTons0"
            :drill1="drillDataTons1"
            :drill2="drillDataTons2"
          />
        </section>
      </div>
    </b-modal>
  </div>
</template>

<script>
import {
  DetailedCarbonIntensity,
  DetailedCarbonIntensities,
  CarbonIntensity,
  CarbonIntensities
} from '@/models/carbon/CarbonIntensity.js'
import '@/plugins/highcharts.js'
import Purchase from '@/models/carbon/Purchase.js'

export default {
  name: 'RegulatoryInventory',
  components: {
    'plots-regulatory': () => import('@/components/carbon/results/PlotsRegulatory.vue'),
    'contrails-switch': () => import('@/components/carbon/utils/ContrailsSwitch.vue')
  },
  data () {
    return {
      graphicTitle: '',
      graphicData0: 100.0,
      graphicData1: 100.0,
      graphicData2: 100.0,
      drillData0: [],
      drillData1: [],
      drillData2: [],
      plotsVisible: false,
      withContrails: false
    }
  },
  computed: {
    graphicDataTons0: function () {
      return (this.graphicData0 / 1000)
    },
    graphicDataTons1: function () {
      return (this.graphicData1 / 1000)
    },
    graphicDataTons2: function () {
      return (this.graphicData2 / 1000)
    },
    drillDataTons0: function () {
      let drillDataTons0 = []
      for (let source of this.drillData0) {
        drillDataTons0.push([source[0], source[1] / 1000])
      }
      return drillDataTons0
    },
    drillDataTons1: function () {
      let drillDataTons1 = []
      for (let source of this.drillData1) {
        drillDataTons1.push([source[0], source[1] / 1000])
      }
      return drillDataTons1
    },
    drillDataTons2: function () {
      let drillDataTons2 = []
      for (let source of this.drillData2) {
        drillDataTons2.push([source[0], source[1] / 1000])
      }
      return drillDataTons2
    },
    intensity: function () {
      let intensity = new CarbonIntensities()
      intensity.add(new CarbonIntensity(
        this.emissionsPostes[5].intensity.intensity,
        this.emissionsPostes[5].intensity.uncertainty
      ))
      intensity.add(new CarbonIntensity(
        this.emissionsPostes[8].intensity.intensity,
        this.emissionsPostes[8].intensity.uncertainty
      ))
      intensity.add(new CarbonIntensity(
        this.emissionsPostes[25].intensity.intensity,
        this.emissionsPostes[25].intensity.uncertainty,
        this.emissionsPostes[25].intensity.intensitywc,
        this.emissionsPostes[25].intensity.uncertaintywc
      ))
      return intensity.sum()
    },
    emissionsPostes: function () {
      return [
        {
          'poste': '1',
          'scope': '1',
          'computed': false,
          'posteDef': this.$t('post-1'),
          '_intensities': new DetailedCarbonIntensities(),
          'intensity': new DetailedCarbonIntensity()
        },
        {
          'poste': '2',
          'scope': '1',
          'computed': false,
          'posteDef': this.$t('post-2'),
          '_intensities': new DetailedCarbonIntensities(),
          'intensity': new DetailedCarbonIntensity()
        },
        {
          'poste': '3',
          'scope': '1',
          'computed': false,
          'posteDef': this.$t('post-3'),
          '_intensities': new DetailedCarbonIntensities(),
          'intensity': new DetailedCarbonIntensity()
        },
        {
          'poste': '4',
          'scope': '1',
          'computed': false,
          'posteDef': this.$t('post-4'),
          '_intensities': new DetailedCarbonIntensities(),
          'intensity': new DetailedCarbonIntensity()
        },
        {
          'poste': '5',
          'scope': '1',
          'computed': false,
          'posteDef': this.$t('post-5'),
          '_intensities': new DetailedCarbonIntensities(),
          'intensity': new DetailedCarbonIntensity()
        },
        {
          'poste': this.$t('sub-total'),
          'scope': '1',
          'computed': true,
          'posteDef': '',
          '_intensities': new CarbonIntensities(),
          'intensity': new CarbonIntensity()
        },
        {
          'poste': '6',
          'scope': '2',
          'computed': false,
          'posteDef': this.$t('post-6'),
          '_intensities': new CarbonIntensities(),
          'intensity': new CarbonIntensity()
        },
        {
          'poste': '7',
          'scope': '2',
          'computed': false,
          'posteDef': this.$t('post-7'),
          '_intensities': new CarbonIntensities(),
          'intensity': new CarbonIntensity()
        },
        {
          'poste': this.$t('sub-total'),
          'scope': '2',
          'computed': true,
          'posteDef': '',
          '_intensities': new CarbonIntensities(),
          'intensity': new CarbonIntensity()
        },
        {
          'poste': '8',
          'scope': '3',
          'computed': false,
          'posteDef': this.$t('post-8'),
          '_intensities': new CarbonIntensities(),
          'intensity': new CarbonIntensity()
        },
        {
          'poste': '9',
          'scope': '3',
          'computed': false,
          'posteDef': this.$t('post-9'),
          '_intensities': new CarbonIntensities(),
          'intensity': new CarbonIntensity()
        },
        {
          'poste': '10',
          'scope': '3',
          'computed': false,
          'posteDef': this.$t('post-10'),
          '_intensities': new CarbonIntensities(),
          'intensity': new CarbonIntensity()
        },
        {
          'poste': '11',
          'scope': '3',
          'computed': false,
          'posteDef': this.$t('post-11'),
          '_intensities': new CarbonIntensities(),
          'intensity': new CarbonIntensity()
        },
        {
          'poste': '12',
          'scope': '3',
          'computed': false,
          'posteDef': this.$t('post-12'),
          '_intensities': new CarbonIntensities(),
          'intensity': new CarbonIntensity()
        },
        {
          'poste': '13',
          'scope': '3',
          'computed': false,
          'posteDef': this.$t('post-13'),
          '_intensities': new CarbonIntensities(),
          'intensity': new CarbonIntensity()
        },
        {
          'poste': '14',
          'scope': '3',
          'computed': false,
          'posteDef': this.$t('post-14'),
          '_intensities': new CarbonIntensities(),
          'intensity': new CarbonIntensity()
        },
        {
          'poste': '15',
          'scope': '3',
          'computed': false,
          'posteDef': this.$t('post-15'),
          '_intensities': new CarbonIntensities(),
          'intensity': new CarbonIntensity()
        },
        {
          'poste': '16',
          'scope': '3',
          'computed': false,
          'posteDef': this.$t('post-16'),
          '_intensities': new CarbonIntensities(),
          'intensity': new CarbonIntensity()
        },
        {
          'poste': '17',
          'scope': '3',
          'computed': false,
          'posteDef': this.$t('post-17'),
          '_intensities': new CarbonIntensities(),
          'intensity': new CarbonIntensity()
        },
        {
          'poste': '18',
          'scope': '3',
          'computed': false,
          'posteDef': this.$t('post-18'),
          '_intensities': new CarbonIntensities(),
          'intensity': new CarbonIntensity()
        },
        {
          'poste': '19',
          'scope': '3',
          'computed': false,
          'posteDef': this.$t('post-19'),
          '_intensities': new CarbonIntensities(),
          'intensity': new CarbonIntensity()
        },
        {
          'poste': '20',
          'scope': '3',
          'computed': false,
          'posteDef': this.$t('post-20'),
          '_intensities': new CarbonIntensities(),
          'intensity': new CarbonIntensity()
        },
        {
          'poste': '21',
          'scope': '3',
          'computed': false,
          'posteDef': this.$t('post-21'),
          '_intensities': new CarbonIntensities(),
          'intensity': new CarbonIntensity()
        },
        {
          'poste': '22',
          'scope': '3',
          'computed': false,
          'posteDef': this.$t('post-22'),
          '_intensities': new CarbonIntensities(),
          'intensity': new CarbonIntensity()
        },
        {
          'poste': '23',
          'scope': '3',
          'computed': false,
          'posteDef': this.$t('post-23'),
          '_intensities': new CarbonIntensities(),
          'intensity': new CarbonIntensity()
        },
        {
          'poste': this.$t('sub-total'),
          'scope': '3',
          'computed': true,
          'posteDef': '',
          '_intensities': new CarbonIntensities(),
          'intensity': new CarbonIntensity()
        }
      ]
    }
  },
  methods: {
    isDetailed (poste) {
      return (poste.intensity instanceof DetailedCarbonIntensity)
    },
    exportTable () {
      let csvContent = 'data:text/csv;charset=utf-8,'
      let now = new Date()
      let month = now.getMonth() + 1
      csvContent += [
        Object.keys(this.emissionsPostes[0]).filter(column => !column.startsWith('_')).join('\t'),
        ...this.emissionsPostes.map(function (item) {
          let toReturn = ''
          for (let colName of Object.keys(item).filter(column => !column.startsWith('_'))) {
            if (colName === 'intensity') {
              toReturn += Math.round(item[colName].intensity) + '\t'
              toReturn += Math.round(item[colName].uncertainty) + '\t'
            } else {
              toReturn += item[colName] + '\t'
            }
          }
          return (toReturn)
        })
      ]
        .join('\n')
        .replace(/(^\[)|(\]$)/gm, '')
      const data = encodeURI(csvContent)
      const link = document.createElement('a')
      link.setAttribute('href', data)
      link.setAttribute('download', 'bilanReglementaire_' + now.getFullYear() + '' + month + '' + now.getDate() + '.tsv')
      link.click()
    },
    setGraphicData () {
      this.drillData0 = []
      this.drillData1 = []
      this.drillData2 = []
      this.graphicData0 = Math.round(this.emissionsPostes[5].intensity.intensity)
      this.graphicData1 = Math.round(this.emissionsPostes[8].intensity.intensity)
      this.graphicData2 = Math.round(this.emissionsPostes[25].intensity.intensity)
      for (let i of [...Array(5).keys()]) {
        if (this.emissionsPostes[i].intensity.intensity > 0) {
          this.drillData0.push([
            this.emissionsPostes[i].posteDef,
            Math.round(this.emissionsPostes[i].intensity.intensity)
          ])
        }
      }
      if (this.emissionsPostes[6].intensity.intensity > 0) {
        this.drillData1.push([
          this.emissionsPostes[6].posteDef,
          Math.round(this.emissionsPostes[6].intensity.intensity)
        ])
      }
      if (this.emissionsPostes[7].intensity.intensity > 0) {
        this.drillData1.push([
          this.emissionsPostes[7].posteDef,
          Math.round(this.emissionsPostes[7].intensity.intensity)
        ])
      }
      let ids = [...Array(16).keys()]
      ids = ids.map(x => x + 9)
      for (let i of ids) {
        if (this.emissionsPostes[i].intensity.intensity > 0) {
          this.drillData2.push([
            this.emissionsPostes[i].posteDef,
            Math.round(this.emissionsPostes[i].intensity.intensity)
          ])
        }
      }
    },
    processBuildings () {
      if (this.$store.getters['buildings/computed']) {
        let results = this.$store.getters['buildings/results']
        let index1 = this.emissionsPostes.findIndex(obj => obj.poste === '1')
        let index4 = this.emissionsPostes.findIndex(obj => obj.poste === '4')
        let index6 = this.emissionsPostes.findIndex(obj => obj.poste === '6')
        let index7 = this.emissionsPostes.findIndex(obj => obj.poste === '7')
        let index8 = this.emissionsPostes.findIndex(obj => obj.poste === '8')

        // heatings intensity
        this.emissionsPostes[index1]._intensities.add(new DetailedCarbonIntensity(
          results.heatings.controled.co2,
          results.heatings.controled.ch4,
          results.heatings.controled.n2o,
          results.heatings.controled.other,
          results.heatings.controled.combustion.intensity,
          results.heatings.controled.combustion.uncertainty
        ))
        this.emissionsPostes[index1].computed = true
        this.emissionsPostes[index7]._intensities.add(new CarbonIntensity(
          results.heatings.uncontroled.combustion.intensity,
          results.heatings.uncontroled.combustion.uncertainty
        ))
        this.emissionsPostes[index7].computed = true
        this.emissionsPostes[index8]._intensities.add(new CarbonIntensity(
          results.heatings.controled.upstream.intensity,
          results.heatings.controled.upstream.uncertainty
        ))
        this.emissionsPostes[index8]._intensities.add(new CarbonIntensity(
          results.heatings.uncontroled.upstream.intensity,
          results.heatings.uncontroled.upstream.uncertainty
        ))
        this.emissionsPostes[index8].computed = true

        // electricity intensity
        this.emissionsPostes[index6]._intensities.add(new CarbonIntensity(
          results.electricity.combustion.intensity,
          results.electricity.combustion.uncertainty
        ))
        this.emissionsPostes[index6].computed = true
        this.emissionsPostes[index8]._intensities.add(new CarbonIntensity(
          results.electricity.upstream.intensity,
          results.electricity.upstream.uncertainty
        ))
        this.emissionsPostes[index8].computed = true

        // refrigerants intensity
        this.emissionsPostes[index4]._intensities.add(new DetailedCarbonIntensity(
          0.0,
          0.0,
          0.0,
          results.refrigerants.intensity,
          results.refrigerants.intensity,
          results.refrigerants.uncertainty
        ))
        this.emissionsPostes[index4].computed = true
      }
    },
    processVehicles () {
      if (this.$store.getters['vehicles/computed']) {
        let results = this.$store.getters['vehicles/results']
        let index2 = this.emissionsPostes.findIndex(obj => obj.poste === '2')
        let index8 = this.emissionsPostes.findIndex(obj => obj.poste === '8')
        let index13 = this.emissionsPostes.findIndex(obj => obj.poste === '13')
        this.emissionsPostes[index2]._intensities.add(new DetailedCarbonIntensity(
          results.controled.co2,
          results.controled.ch4,
          results.controled.n2o,
          results.controled.other,
          results.controled.combustion.intensity,
          results.controled.combustion.uncertainty
        ))
        this.emissionsPostes[index2].computed = true
        this.emissionsPostes[index8]._intensities.add(new CarbonIntensity(
          results.controled.upstream.intensity,
          results.controled.upstream.uncertainty
        ))
        this.emissionsPostes[index8].computed = true
        this.emissionsPostes[index13]._intensities.add(new CarbonIntensity(
          results.controled.manufacturing.intensity,
          results.controled.manufacturing.uncertainty
        ))
        this.emissionsPostes[index13]._intensities.add(new CarbonIntensity(
          results.uncontroled.intensity,
          results.uncontroled.uncertainty
        ))
        this.emissionsPostes[index13].computed = true
      }
    },
    processCommutes () {
      if (this.$store.getters['commutes/computed']) {
        let results = this.$store.getters['commutes/results']
        // add the value to the right post
        let index22 = this.emissionsPostes.findIndex(obj => obj.poste === '22')
        this.emissionsPostes[index22]._intensities.add(results.intensity)
        this.emissionsPostes[index22].computed = true
      }
    },
    processMissions () {
      if (this.$store.getters['travels/computed']) {
        let results = this.$store.getters['travels/results']
        // add the value to the right post
        let index13 = this.emissionsPostes.findIndex(obj => obj.poste === '13')
        this.emissionsPostes[index13]._intensities.add(results.intensity)
        this.emissionsPostes[index13].computed = true
      }
    },
    processComputerDevices () {
      if (this.$store.getters['computerdevices/computed']) {
        let results = this.$store.getters['computerdevices/results']
        // add the value to the right post
        let index10 = this.emissionsPostes.findIndex(obj => obj.poste === '10')
        this.emissionsPostes[index10]._intensities.add(results.intensity)
        this.emissionsPostes[index10].computed = true
      }
    },
    processPurchases () {
      if (this.$store.getters['purchases/computed']) {
        let results = this.$store.getters['purchases/results']
        // add the value to the right post
        for (let scat of Object.keys(results.scope3)) {
          let cindex = this.emissionsPostes.findIndex(obj => obj.poste === scat)
          if (cindex !== -1) {
            this.emissionsPostes[cindex]._intensities.add(results.scope3[scat])
          }
        }
        // set as computed all purchases scopes
        for (let scope3 of Purchase.getScope3()) {
          let cindex = this.emissionsPostes.findIndex(obj => obj.poste === scope3.toString())
          if (cindex !== -1) {
            this.emissionsPostes[cindex].computed = true
          }
        }
      }
    },
    resetEmissionsPostes () {
      for (let emission of this.emissionsPostes) {
        if (parseInt(emission.poste) < 6) {
          emission._intensities = new DetailedCarbonIntensities()
        } else {
          emission._intensities = new CarbonIntensities()
        }
      }
    },
    updateValues () {
      this.emissionsPostes[5]._intensities = new CarbonIntensities()
      for (let i of [...Array(5).keys()]) {
        this.emissionsPostes[5]._intensities.add(this.emissionsPostes[i]._intensities)
      }
      this.emissionsPostes[8]._intensities = new CarbonIntensities()
      this.emissionsPostes[8]._intensities.add(this.emissionsPostes[6]._intensities)
      this.emissionsPostes[8]._intensities.add(this.emissionsPostes[7]._intensities)
      this.emissionsPostes[25]._intensities = new CarbonIntensities()
      let ids = [...Array(16).keys()]
      ids = ids.map(x => x + 9)
      for (let i of ids) {
        this.emissionsPostes[25]._intensities.add(this.emissionsPostes[i]._intensities)
      }
      for (let emission of this.emissionsPostes) {
        emission.intensity = emission._intensities.sum()
      }
    },
    process () {
      // reset values
      this.resetEmissionsPostes()
      if (!this.$store.getters['buildings/computed']) {
        this.$store.dispatch('buildings/compute')
      }
      if (!this.$store.getters['vehicles/computed']) {
        this.$store.dispatch('vehicles/compute')
      }
      if (!this.$store.getters['commutes/computed']) {
        this.$store.dispatch('commutes/compute')
      }
      if (!this.$store.getters['travels/computed']) {
        this.$store.dispatch('travels/compute')
      }
      if (!this.$store.getters['computerdevices/computed']) {
        this.$store.dispatch('computerdevices/compute')
      }
      if (!this.$store.getters['purchases/computed']) {
        this.$store.dispatch('purchases/compute')
      }
      this.processBuildings()
      this.processVehicles()
      this.processCommutes()
      this.processMissions()
      this.processComputerDevices()
      this.processPurchases()
      // update final values
      this.updateValues()
      // affichage des graphs
      this.setGraphicData()
    }
  },
  watch: {
    '$i18n.locale': function () {
      this.process()
    }
  },
  mounted () {
    this.process()
  }
}
</script>
